'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Editor = function (_React$Component) {
  _inherits(Editor, _React$Component);

  function Editor(props) {
    _classCallCheck(this, Editor);

    var _this = _possibleConstructorReturn(this, (Editor.__proto__ || Object.getPrototypeOf(Editor)).call(this, props));

    _this.state = {
      current: props.item
    };
    _this.onCancel = _this.onCancel.bind(_this);
    _this.onChange = _this.onChange.bind(_this);
    _this.onSave = _this.onSave.bind(_this);
    return _this;
  }

  _createClass(Editor, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var item = nextProps.item;

      this.setState({
        current: item
      });
    }
  }, {
    key: 'onCancel',
    value: function onCancel(e) {
      e.preventDefault();
      this.setState({
        current: this.props.item
      });
      if (this.props.onCancel) {
        this.props.onCancel(e);
      }
    }
  }, {
    key: 'onChange',
    value: function onChange(e) {
      this.setState({
        current: this.props.onChange(e, this.state.current)
      });
    }
  }, {
    key: 'onSave',
    value: function onSave(e) {
      e.preventDefault();
      this.props.onSave(this.state.current);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          id = _props.id,
          formElements = _props.formElements;


      var childrenWithProps = _react2.default.Children.map(formElements(this.state.current), function (child) {
        return _react2.default.cloneElement(child, {
          onChange: _this2.onChange
        });
      });

      return _react2.default.createElement(
        'div',
        { id: 'defaultForm' },
        childrenWithProps,
        _react2.default.createElement(
          'button',
          { id: 'submit_form_' + id, onClick: this.onSave, className: 'btn btn-success', type: 'button' },
          'Save'
        ),
        _react2.default.createElement(
          'button',
          { id: 'cancel_form_' + id, onClick: this.onCancel, className: 'btn btn-default', type: 'button' },
          'Cancel'
        )
      );
    }
  }]);

  return Editor;
}(_react2.default.Component);

Editor.propTypes = {
  formElements: _propTypes2.default.func.isRequired,
  id: _propTypes2.default.string.isRequired,
  item: _propTypes2.default.object.isRequired,
  onCancel: _propTypes2.default.func.isRequired,
  onChange: _propTypes2.default.func.isRequired,
  onSave: _propTypes2.default.func.isRequired
};

exports.default = Editor;