'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRte = require('react-rte');

var _reactRte2 = _interopRequireDefault(_reactRte);

var _FormGroup = require('./FormGroup');

var _FormGroup2 = _interopRequireDefault(_FormGroup);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TextAreaFormGroup = function (_React$Component) {
  _inherits(TextAreaFormGroup, _React$Component);

  function TextAreaFormGroup(props) {
    _classCallCheck(this, TextAreaFormGroup);

    var _this = _possibleConstructorReturn(this, (TextAreaFormGroup.__proto__ || Object.getPrototypeOf(TextAreaFormGroup)).call(this, props));

    _this.setValue(props.value);
    _this.state = {
      value: (0, _reactRte.createEmptyValue)()
    };
    _this.changeThis = _this.changeThis.bind(_this);
    return _this;
  }

  _createClass(TextAreaFormGroup, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(props) {
      this.setValue(props.value);
    }
  }, {
    key: 'changeThis',
    value: function changeThis(value) {
      this.setState({ value: value });
      if (this.props.onChange) {
        this.props.onChange({
          target: {
            id: this.props.id,
            value: value.toString('markdown')
          }
        });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          error = _props.error,
          id = _props.id,
          label = _props.label,
          required = _props.required;

      return _react2.default.createElement(
        _FormGroup2.default,
        { label: label, id: id, error: error, required: required },
        _react2.default.createElement(_reactRte2.default, { webDriverTestID: id, onChange: this.changeThis, value: this.state.value })
      );
    }
  }, {
    key: 'setValue',
    value: function setValue(valueString) {
      var value = null;
      if (valueString) {
        value = (0, _reactRte.createValueFromString)(valueString, 'markdown');
      } else {
        value = (0, _reactRte.createEmptyValue)();
      }
      this.state = {
        value: value
      };
    }
  }]);

  return TextAreaFormGroup;
}(_react2.default.Component);

exports.default = TextAreaFormGroup;


TextAreaFormGroup.defaultProps = {
  disabled: false,
  required: false
};

TextAreaFormGroup.propTypes = {

  error: _propTypes2.default.string,
  id: _propTypes2.default.string.isRequired,
  label: _propTypes2.default.string,
  onChange: _propTypes2.default.func.isRequired,
  required: _propTypes2.default.bool,
  value: _propTypes2.default.string
};